Home | Namespaces | Hierarchy | Alphabetical List | Class list | Files | Namespace Members | Class members | File members | Tutorials

# irr::core::vector3d< T > Class Template Reference

3d vector template class with lots of operators and methods. More...

`#include <vector3d.h>`

List of all members.

## Public Member Functions
vector3d< T > | crossProduct (const vector3d< T > &p) const
| Calculates the cross product with another vector.
T | dotProduct (const vector3d< T > &other) const
| Get the dot product with another vector.
bool | equals (const vector3d< T > &other, const T tolerance=(T) ROUNDING_ERROR_f32) const
| returns if this vector equals the other one, taking floating point rounding errors into account
void | getAs4Values (T *array) const
| Fills an array of 4 values with the vector data (usually floats).
T | getDistanceFrom (const vector3d< T > &other) const
| Get distance from another point.
T | getDistanceFromSQ (const vector3d< T > &other) const
| Returns squared distance from another point.
vector3d< T > | getHorizontalAngle () const
| Get the rotations that would make a (0,0,1) direction vector point in the same direction as this direction vector.
vector3d< T > | getInterpolated (const vector3d< T > &other, f64 d) const
| Creates an interpolated vector between this vector and another vector.
vector3d< T > | getInterpolated_quadratic (const vector3d< T > &v2, const vector3d< T > &v3, f64 d) const
| Creates a quadratically interpolated vector between this and two other vectors.
T | getLength () const
| Get length of the vector.
T | getLengthSQ () const
| Get squared length of the vector.
vector3d< T > & | interpolate (const vector3d< T > &a, const vector3d< T > &b, f64 d)
| Sets this vector to the linearly interpolated vector between a and b.
vector3d< T > & | invert ()
| Inverts the vector.
bool | isBetweenPoints (const vector3d< T > &begin, const vector3d< T > &end) const
| Returns if this vector interpreted as a point is on a line between two other points.
vector3d< T > & | normalize ()
| Normalizes the vector.
bool | operator!= (const vector3d< T > &other) const
vector3d< T > | operator* (const T v) const
vector3d< T > | operator* (const vector3d< T > &other) const
vector3d< T > & | operator*= (const T v)
vector3d< T > & | operator*= (const vector3d< T > &other)
vector3d< T > | operator+ (const T val) const
vector3d< T > | operator+ (const vector3d< T > &other) const
vector3d< T > & | operator+= (const T val)
vector3d< T > & | operator+= (const vector3d< T > &other)
vector3d< T > | operator- (const T val) const
vector3d< T > | operator- (const vector3d< T > &other) const
vector3d< T > | operator- () const
vector3d< T > & | operator-= (const T val)
vector3d< T > & | operator-= (const vector3d< T > &other)
vector3d< T > | operator/ (const T v) const
vector3d< T > | operator/ (const vector3d< T > &other) const
vector3d< T > & | operator/= (const T v)
vector3d< T > & | operator/= (const vector3d< T > &other)
bool | operator< (const vector3d< T > &other) const
bool | operator<= (const vector3d< T > &other) const
vector3d< T > & | operator= (const vector3d< T > &other)
bool | operator== (const vector3d< T > &other) const
| use weak float compare
bool | operator> (const vector3d< T > &other) const
bool | operator>= (const vector3d< T > &other) const
void | rotateXYBy (f64 degrees, const vector3d< T > &center=vector3d< T >())
| Rotates the vector by a specified number of degrees around the Z axis and the specified center.
void | rotateXZBy (f64 degrees, const vector3d< T > &center=vector3d< T >())
| Rotates the vector by a specified number of degrees around the Y axis and the specified center.
void | rotateYZBy (f64 degrees, const vector3d< T > &center=vector3d< T >())
| Rotates the vector by a specified number of degrees around the X axis and the specified center.
vector3d< T > | rotationToDirection (const vector3d< T > &forwards=vector3d< T >(0, 0, 1)) const
| Builds a direction vector from (this) rotation vector.
vector3d< T > & | set (const vector3d< T > &p)
vector3d< T > & | set (const T nx, const T ny, const T nz)
vector3d< T > & | setLength (T newlength)
| Sets the length of the vector to a new value.
| vector3d (const vector3d< T > &other)
| Copy constructor.
| vector3d (T n)
| Constructor with the same value for all elements.
| vector3d (T nx, T ny, T nz)
| Constructor with three different values.
| vector3d ()
| Default constructor (null vector).
## Public Attributes
T | X
| X coordinate of the vector.
T | Y
| Y coordinate of the vector.
T | Z
| Z coordinate of the vector.

## Detailed Description

### template<class T>
class irr::core::vector3d< T >

3d vector template class with lots of operators and methods.

The vector3d class is used in Irrlicht for three main purposes: 1) As a direction vector (most of the methods assume this). 2) As a position in 3d space (which is synonymous with a direction vector from the origin to this position). 3) To hold three Euler rotations, where X is pitch, Y is yaw and Z is roll.

Definition at line 22 of file vector3d.h.

## Constructor & Destructor Documentation

template<class T>

irr::core::vector3d< T >::vector3d | ( |  | ) | `[inline]`

Default constructor (null vector).

Definition at line 26 of file vector3d.h.

template<class T>

irr::core::vector3d< T >::vector3d | ( | T | nx,
|  | T | ny,
|  | T | nz |
| ) |  |  | `[inline]`

Constructor with three different values.

Definition at line 28 of file vector3d.h.

template<class T>

irr::core::vector3d< T >::vector3d | ( | T | n | ) | `[inline, explicit]`

Constructor with the same value for all elements.

Definition at line 30 of file vector3d.h.

template<class T>

irr::core::vector3d< T >::vector3d | ( | const vector3d< T > & | other | ) | `[inline]`

Copy constructor.

Definition at line 32 of file vector3d.h.

## Member Function Documentation

template<class T>

vector3d<T> irr::core::vector3d< T >::crossProduct | ( | const vector3d< T > & | p | ) | const`[inline]`

Calculates the cross product with another vector.

Parameters:

  | p | Vector to multiply with.

Returns:
  Crossproduct of this vector with p.

Definition at line 120 of file vector3d.h.

Referenced by irr::core::CMatrix4< T >::buildAxisAlignedBillboard(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixLH(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixRH(), irr::core::CMatrix4< T >::buildRotateFromTo(), irr::core::quaternion::operator*(), and irr::core::quaternion::rotationFromTo().

template<class T>

T irr::core::vector3d< T >::dotProduct | ( | const vector3d< T > & | other | ) | const`[inline]`

Get the dot product with another vector.

Definition at line 98 of file vector3d.h.

Referenced by irr::core::CMatrix4< T >::buildAxisAlignedBillboard(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixLH(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixRH(), irr::core::CMatrix4< T >::buildRotateFromTo(), irr::core::line3d< T >::getClosestPoint(), irr::core::plane3d< float >::getDistanceTo(), irr::core::triangle3d< T >::getIntersectionOfPlaneWithLine(), irr::core::line3d< T >::getIntersectionWithSphere(), irr::core::triangle3d< T >::isFrontFacing(), irr::core::triangle3d< T >::isPointInsideFast(), irr::core::plane3d< float >::recalculateD(), and irr::core::quaternion::rotationFromTo().

template<class T>

bool irr::core::vector3d< T >::equals | ( | const vector3d< T > & | other,
|  | const T | tolerance = `(T)ROUNDING_ERROR_f32` |
| ) |  |  | const`[inline]`

returns if this vector equals the other one, taking floating point rounding errors into account

Definition at line 79 of file vector3d.h.

Referenced by irr::core::vector3d< float >::operator!=(), and irr::core::vector3d< float >::operator==().

template<class T>

void irr::core::vector3d< T >::getAs4Values | ( | T * | array | ) | const`[inline]`

Fills an array of 4 values with the vector data (usually floats).

Useful for setting in shader constants for example. The fourth value will always be 0.

Definition at line 337 of file vector3d.h.

template<class T>

T irr::core::vector3d< T >::getDistanceFrom | ( | const vector3d< T > & | other | ) | const`[inline]`

Get distance from another point.

Here, the vector is interpreted as point in 3 dimensional space.

Definition at line 105 of file vector3d.h.

Referenced by irr::core::triangle3d< T >::closestPointOnTriangle().

template<class T>

T irr::core::vector3d< T >::getDistanceFromSQ | ( | const vector3d< T > & | other | ) | const`[inline]`

Returns squared distance from another point.

Here, the vector is interpreted as point in 3 dimensional space.

Definition at line 112 of file vector3d.h.

Referenced by irr::core::vector3d< float >::isBetweenPoints().

template<class T>

vector3d<T> irr::core::vector3d< T >::getHorizontalAngle | ( |  | ) | const`[inline]`

Get the rotations that would make a (0,0,1) direction vector point in the same direction as this direction vector.

Thanks to Arras on the Irrlicht forums for this method. This utility method is very useful for orienting scene nodes towards specific targets. For example, if this vector represents the difference between two scene nodes, then applying the result of getHorizontalAngle() to one scene node will point it at the other one. Example code: Where target and seeker are of type ISceneNode* const vector3df toTarget(target->getAbsolutePosition() - seeker->getAbsolutePosition()); const vector3df requiredRotation = toTarget.getHorizontalAngle(); seeker->setRotation(requiredRotation);

Returns:
  A rotation vector containing the X (pitch) and Y (raw) rotations (in degrees) that when applied to a +Z (e.g. 0, 0, 1) direction vector would make it point in the same direction as this vector. The Z (roll) rotation is always 0, since two Euler rotations are sufficient to point in any given direction.

Definition at line 274 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::getInterpolated | ( | const vector3d< T > & | other,
|  | f64 | d |
| ) |  |  | const`[inline]`

Creates an interpolated vector between this vector and another vector.

Parameters:

  | other | The other vector to interpolate with.
  | d | Interpolation value between 0.0f (all the other vector) and 1.0f (all this vector). Note that this is the opposite direction of interpolation to getInterpolated_quadratic()

Returns:
  An interpolated vector. This vector is not modified.

Definition at line 220 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::getInterpolated_quadratic | ( | const vector3d< T > & | v2,
|  | const vector3d< T > & | v3,
|  | f64 | d |
| ) |  |  | const`[inline]`

Creates a quadratically interpolated vector between this and two other vectors.

Parameters:

  | v2 | Second vector to interpolate with.
  | v3 | Third vector to interpolate with (maximum at 1.0f)
  | d | Interpolation value between 0.0f (all this vector) and 1.0f (all the 3rd vector). Note that this is the opposite direction of interpolation to getInterpolated() and interpolate()

Returns:
  An interpolated vector. This vector is not modified.

Definition at line 232 of file vector3d.h.

template<class T>

T irr::core::vector3d< T >::getLength | ( |  | ) | const`[inline]`

Get length of the vector.

Definition at line 90 of file vector3d.h.

Referenced by irr::core::plane3d< float >::existsIntersection(), irr::core::line3d< T >::getClosestPoint(), irr::core::vector3d< float >::getDistanceFrom(), and irr::core::line3d< T >::getIntersectionWithSphere().

template<class T>

T irr::core::vector3d< T >::getLengthSQ | ( |  | ) | const`[inline]`

Get squared length of the vector.

This is useful because it is much faster than getLength().

Returns:
  Squared length of the vector.

Definition at line 95 of file vector3d.h.

Referenced by irr::core::vector3d< float >::getDistanceFromSQ(), and irr::core::vector3d< float >::isBetweenPoints().

template<class T>

vector3d<T>& irr::core::vector3d< T >::interpolate | ( | const vector3d< T > & | a,
|  | const vector3d< T > & | b,
|  | f64 | d |
| ) |  |  | `[inline]`

Sets this vector to the linearly interpolated vector between a and b.

Parameters:

  | a | first vector to interpolate with, maximum at 1.0f
  | b | second vector to interpolate with, maximum at 0.0f
  | d | Interpolation value between 0.0f (all vector b) and 1.0f (all vector a) Note that this is the opposite direction of interpolation to getInterpolated_quadratic()

Definition at line 251 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::invert | ( |  | ) | `[inline]`

Inverts the vector.

Definition at line 162 of file vector3d.h.

template<class T>

bool irr::core::vector3d< T >::isBetweenPoints | ( | const vector3d< T > & | begin,
|  | const vector3d< T > & | end |
| ) |  |  | const`[inline]`

Returns if this vector interpreted as a point is on a line between two other points.

It is assumed that the point is on the line.

Parameters:

  | begin | Beginning vector to compare between.
  | end | Ending vector to compare between.

Returns:
  True if this vector is between begin and end, false if not.

Definition at line 130 of file vector3d.h.

Referenced by irr::core::triangle3d< T >::getIntersectionWithLimitedLine(), irr::core::plane3d< float >::getIntersectionWithLimitedLine(), and irr::core::line3d< T >::isPointBetweenStartAndEnd().

template<class T>

vector3d<T>& irr::core::vector3d< T >::normalize | ( |  | ) | `[inline]`

Normalizes the vector.

In case of the 0 vector the result is still 0, otherwise the length of the vector will be 1.

Returns:
  Reference to this vector after normalization.

Definition at line 141 of file vector3d.h.

Referenced by irr::core::CMatrix4< T >::buildAxisAlignedBillboard(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixLH(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixRH(), irr::core::CMatrix4< T >::buildRotateFromTo(), irr::core::quaternion::rotationFromTo(), and irr::core::vector3d< float >::setLength().

template<class T>

bool irr::core::vector3d< T >::operator!= | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 71 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator* | ( | const T | v | ) | const`[inline]`

Definition at line 52 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator* | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 50 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator*= | ( | const T | v | ) | `[inline]`

Definition at line 53 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator*= | ( | const vector3d< T > & | other | ) | `[inline]`

Definition at line 51 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator+ | ( | const T | val | ) | const`[inline]`

Definition at line 42 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator+ | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 40 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator+= | ( | const T | val | ) | `[inline]`

Definition at line 43 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator+= | ( | const vector3d< T > & | other | ) | `[inline]`

Definition at line 41 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator- | ( | const T | val | ) | const`[inline]`

Definition at line 47 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator- | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 45 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator- | ( |  | ) | const`[inline]`

Definition at line 36 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator-= | ( | const T | val | ) | `[inline]`

Definition at line 48 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator-= | ( | const vector3d< T > & | other | ) | `[inline]`

Definition at line 46 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator/ | ( | const T | v | ) | const`[inline]`

Definition at line 57 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::operator/ | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 55 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator/= | ( | const T | v | ) | `[inline]`

Definition at line 58 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator/= | ( | const vector3d< T > & | other | ) | `[inline]`

Definition at line 56 of file vector3d.h.

template<class T>

bool irr::core::vector3d< T >::operator< | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 62 of file vector3d.h.

template<class T>

bool irr::core::vector3d< T >::operator<= | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 60 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::operator= | ( | const vector3d< T > & | other | ) | `[inline]`

Definition at line 38 of file vector3d.h.

template<class T>

bool irr::core::vector3d< T >::operator== | ( | const vector3d< T > & | other | ) | const`[inline]`

use weak float compare

Definition at line 66 of file vector3d.h.

template<class T>

bool irr::core::vector3d< T >::operator> | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 63 of file vector3d.h.

template<class T>

bool irr::core::vector3d< T >::operator>= | ( | const vector3d< T > & | other | ) | const`[inline]`

Definition at line 61 of file vector3d.h.

template<class T>

void irr::core::vector3d< T >::rotateXYBy | ( | f64 | degrees,
|  | const vector3d< T > & | center = `vector3d<T>()` |
| ) |  |  | `[inline]`

Rotates the vector by a specified number of degrees around the Z axis and the specified center.

Parameters:

  | degrees,: | Number of degrees to rotate around the Z axis.
  | center,: | The center of the rotation.

Definition at line 188 of file vector3d.h.

template<class T>

void irr::core::vector3d< T >::rotateXZBy | ( | f64 | degrees,
|  | const vector3d< T > & | center = `vector3d<T>()` |
| ) |  |  | `[inline]`

Rotates the vector by a specified number of degrees around the Y axis and the specified center.

Parameters:

  | degrees | Number of degrees to rotate around the Y axis.
  | center | The center of the rotation.

Definition at line 173 of file vector3d.h.

template<class T>

void irr::core::vector3d< T >::rotateYZBy | ( | f64 | degrees,
|  | const vector3d< T > & | center = `vector3d<T>()` |
| ) |  |  | `[inline]`

Rotates the vector by a specified number of degrees around the X axis and the specified center.

Parameters:

  | degrees,: | Number of degrees to rotate around the X axis.
  | center,: | The center of the rotation.

Definition at line 203 of file vector3d.h.

template<class T>

vector3d<T> irr::core::vector3d< T >::rotationToDirection | ( | const vector3d< T > & | forwards = `vector3d<T>(0, 0, 1)` | ) | const`[inline]`

Builds a direction vector from (this) rotation vector.

This vector is assumed to be a rotation vector composed of 3 Euler angle rotations, in degrees. The implementation performs the same calculations as using a matrix to do the rotation.

Parameters:

  `[in]` | forwards | The direction representing "forwards" which will be rotated by this vector. If you do not provide a direction, then the +Z axis (0, 0, 1) will be assumed to be forwards.

Returns:
  A direction vector calculated by rotating the forwards direction by the 3 Euler angles (in degrees) represented by this vector.

Definition at line 305 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::set | ( | const vector3d< T > & | p | ) | `[inline]`

Definition at line 87 of file vector3d.h.

template<class T>

vector3d<T>& irr::core::vector3d< T >::set | ( | const T | nx,
|  | const T | ny,
|  | const T | nz |
| ) |  |  | `[inline]`

Definition at line 86 of file vector3d.h.

Referenced by irr::core::aabbox3d< float >::getEdges().

template<class T>

vector3d<T>& irr::core::vector3d< T >::setLength | ( | T | newlength | ) | `[inline]`

Sets the length of the vector to a new value.

Definition at line 155 of file vector3d.h.

## Member Data Documentation

template<class T>

T irr::core::vector3d< T >::X

X coordinate of the vector.

Definition at line 346 of file vector3d.h.

Referenced by irr::core::aabbox3d< float >::addInternalPoint(), irr::core::CMatrix4< T >::buildAxisAlignedBillboard(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixLH(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixRH(), irr::core::CMatrix4< T >::buildRotateFromTo(), irr::core::CMatrix4< T >::buildShadowMatrix(), irr::core::aabbox3d< float >::classifyPlaneRelation(), irr::core::vector3d< float >::crossProduct(), irr::core::vector3d< float >::dotProduct(), irr::core::vector3d< float >::equals(), irr::core::quaternion::fromAngleAxis(), irr::core::aabbox3d< float >::getArea(), irr::scene::quake3::getAsVector3df(), irr::core::vector3d< float >::getDistanceFrom(), irr::core::vector3d< float >::getDistanceFromSQ(), irr::core::aabbox3d< float >::getEdges(), irr::core::vector3d< float >::getHorizontalAngle(), irr::core::vector3d< float >::getInterpolated(), irr::core::vector3d< float >::getInterpolated_quadratic(), irr::core::vector3d< float >::getLength(), irr::core::vector3d< float >::getLengthSQ(), irr::core::quaternion::getMatrix(), irr::core::aabbox3d< float >::getVolume(), irr::core::vector3d< float >::interpolate(), irr::core::aabbox3d< float >::intersectsWithLine(), irr::core::CMatrix4< T >::inverseRotateVect(), irr::core::CMatrix4< T >::inverseTranslateVect(), irr::core::vector3d< float >::invert(), irr::core::aabbox3d< float >::isPointInside(), irr::core::aabbox3d< float >::isPointTotalInside(), irr::core::vector3d< float >::normalize(), irr::core::vector3d< float >::operator*(), irr::core::vector3d< float >::operator*=(), irr::core::vector3d< float >::operator+(), irr::core::vector3d< float >::operator+=(), irr::core::vector3d< float >::operator-(), irr::core::vector3d< float >::operator-=(), irr::core::vector3d< float >::operator/(), irr::core::vector3d< float >::operator/=(), irr::core::vector3d< float >::operator<(), irr::core::vector3d< float >::operator<=(), irr::core::vector3d< float >::operator=(), irr::core::vector3d< float >::operator>(), irr::core::vector3d< float >::operator>=(), irr::core::quaternion::quaternion(), irr::core::CMatrix4< T >::rotateVect(), irr::core::vector3d< float >::rotateXYBy(), irr::core::vector3d< float >::rotateXZBy(), irr::core::vector3d< float >::rotateYZBy(), irr::core::quaternion::rotationFromTo(), irr::core::vector3d< float >::rotationToDirection(), irr::core::vector3d< float >::set(), irr::core::quaternion::set(), irr::core::CMatrix4< T >::setInverseRotationRadians(), irr::core::CMatrix4< T >::setInverseTranslation(), irr::core::CMatrix4< T >::setRotationCenter(), irr::core::CMatrix4< T >::setRotationRadians(), irr::core::CMatrix4< T >::setScale(), irr::core::CMatrix4< T >::setTranslation(), irr::core::quaternion::toAngleAxis(), irr::core::quaternion::toEuler(), irr::core::CMatrix4< T >::transformVect(), irr::core::CMatrix4< T >::translateVect(), and irr::scene::SMD3QuaternionTag::~SMD3QuaternionTag().

template<class T>

T irr::core::vector3d< T >::Y

Y coordinate of the vector.

Definition at line 349 of file vector3d.h.

Referenced by irr::core::aabbox3d< float >::addInternalPoint(), irr::core::CMatrix4< T >::buildAxisAlignedBillboard(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixLH(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixRH(), irr::core::CMatrix4< T >::buildRotateFromTo(), irr::core::CMatrix4< T >::buildShadowMatrix(), irr::core::aabbox3d< float >::classifyPlaneRelation(), irr::core::vector3d< float >::crossProduct(), irr::core::vector3d< float >::dotProduct(), irr::core::vector3d< float >::equals(), irr::core::quaternion::fromAngleAxis(), irr::core::aabbox3d< float >::getArea(), irr::scene::quake3::getAsVector3df(), irr::core::vector3d< float >::getDistanceFrom(), irr::core::vector3d< float >::getDistanceFromSQ(), irr::core::aabbox3d< float >::getEdges(), irr::core::vector3d< float >::getHorizontalAngle(), irr::core::vector3d< float >::getInterpolated(), irr::core::vector3d< float >::getInterpolated_quadratic(), irr::core::vector3d< float >::getLength(), irr::core::vector3d< float >::getLengthSQ(), irr::core::quaternion::getMatrix(), irr::core::aabbox3d< float >::getVolume(), irr::core::vector3d< float >::interpolate(), irr::core::aabbox3d< float >::intersectsWithLine(), irr::core::CMatrix4< T >::inverseRotateVect(), irr::core::CMatrix4< T >::inverseTranslateVect(), irr::core::vector3d< float >::invert(), irr::core::aabbox3d< float >::isPointInside(), irr::core::aabbox3d< float >::isPointTotalInside(), irr::core::vector3d< float >::normalize(), irr::core::vector3d< float >::operator*(), irr::core::vector3d< float >::operator*=(), irr::core::vector3d< float >::operator+(), irr::core::vector3d< float >::operator+=(), irr::core::vector3d< float >::operator-(), irr::core::vector3d< float >::operator-=(), irr::core::vector3d< float >::operator/(), irr::core::vector3d< float >::operator/=(), irr::core::vector3d< float >::operator<(), irr::core::vector3d< float >::operator<=(), irr::core::vector3d< float >::operator=(), irr::core::vector3d< float >::operator>(), irr::core::vector3d< float >::operator>=(), irr::core::quaternion::quaternion(), irr::core::CMatrix4< T >::rotateVect(), irr::core::vector3d< float >::rotateXYBy(), irr::core::vector3d< float >::rotateXZBy(), irr::core::vector3d< float >::rotateYZBy(), irr::core::quaternion::rotationFromTo(), irr::core::vector3d< float >::rotationToDirection(), irr::core::vector3d< float >::set(), irr::core::quaternion::set(), irr::core::CMatrix4< T >::setInverseRotationRadians(), irr::core::CMatrix4< T >::setInverseTranslation(), irr::core::CMatrix4< T >::setRotationCenter(), irr::core::CMatrix4< T >::setRotationRadians(), irr::core::CMatrix4< T >::setScale(), irr::core::CMatrix4< T >::setTranslation(), irr::core::quaternion::toAngleAxis(), irr::core::quaternion::toEuler(), irr::core::CMatrix4< T >::transformVect(), and irr::core::CMatrix4< T >::translateVect().

template<class T>

T irr::core::vector3d< T >::Z

Z coordinate of the vector.

Definition at line 352 of file vector3d.h.

Referenced by irr::core::aabbox3d< float >::addInternalPoint(), irr::core::CMatrix4< T >::buildAxisAlignedBillboard(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixLH(), irr::core::CMatrix4< T >::buildCameraLookAtMatrixRH(), irr::core::CMatrix4< T >::buildRotateFromTo(), irr::core::CMatrix4< T >::buildShadowMatrix(), irr::core::aabbox3d< float >::classifyPlaneRelation(), irr::core::vector3d< float >::crossProduct(), irr::core::vector3d< float >::dotProduct(), irr::core::vector3d< float >::equals(), irr::core::quaternion::fromAngleAxis(), irr::core::aabbox3d< float >::getArea(), irr::scene::quake3::getAsVector3df(), irr::core::vector3d< float >::getDistanceFrom(), irr::core::vector3d< float >::getDistanceFromSQ(), irr::core::aabbox3d< float >::getEdges(), irr::core::vector3d< float >::getHorizontalAngle(), irr::core::vector3d< float >::getInterpolated(), irr::core::vector3d< float >::getInterpolated_quadratic(), irr::core::vector3d< float >::getLength(), irr::core::vector3d< float >::getLengthSQ(), irr::core::quaternion::getMatrix(), irr::core::aabbox3d< float >::getVolume(), irr::core::vector3d< float >::interpolate(), irr::core::aabbox3d< float >::intersectsWithLine(), irr::core::CMatrix4< T >::inverseRotateVect(), irr::core::CMatrix4< T >::inverseTranslateVect(), irr::core::vector3d< float >::invert(), irr::core::aabbox3d< float >::isPointInside(), irr::core::aabbox3d< float >::isPointTotalInside(), irr::core::vector3d< float >::normalize(), irr::core::vector3d< float >::operator*(), irr::core::vector3d< float >::operator*=(), irr::core::vector3d< float >::operator+(), irr::core::vector3d< float >::operator+=(), irr::core::vector3d< float >::operator-(), irr::core::vector3d< float >::operator-=(), irr::core::vector3d< float >::operator/(), irr::core::vector3d< float >::operator/=(), irr::core::vector3d< float >::operator<(), irr::core::vector3d< float >::operator<=(), irr::core::vector3d< float >::operator=(), irr::core::vector3d< float >::operator>(), irr::core::vector3d< float >::operator>=(), irr::core::quaternion::quaternion(), irr::core::CMatrix4< T >::rotateVect(), irr::core::vector3d< float >::rotateXYBy(), irr::core::vector3d< float >::rotateXZBy(), irr::core::vector3d< float >::rotateYZBy(), irr::core::quaternion::rotationFromTo(), irr::core::vector3d< float >::rotationToDirection(), irr::core::vector3d< float >::set(), irr::core::quaternion::set(), irr::core::CMatrix4< T >::setInverseRotationRadians(), irr::core::CMatrix4< T >::setInverseTranslation(), irr::core::CMatrix4< T >::setRotationCenter(), irr::core::CMatrix4< T >::setRotationRadians(), irr::core::CMatrix4< T >::setScale(), irr::core::CMatrix4< T >::setTranslation(), irr::core::quaternion::toAngleAxis(), irr::core::quaternion::toEuler(), irr::core::CMatrix4< T >::transformVect(), and irr::core::CMatrix4< T >::translateVect().

The documentation for this class was generated from the following file:

- vector3d.h

| The Irrlicht Engine Documentation © 2003-2009 by Nikolaus Gebhardt. Generated on Sun Jan 10 09:24:10 2010 by Doxygen (1.5.6)